module fifo_simple_hier_bench;
  reg [63:0] data_in;
  reg        data_in_valid;
  reg        pop_fifo;

  wire [63:0] data_out;
  wire        fifo_empty;
  wire        fifo_full;
  wire        data_out_valid;

  reg        err;
  wire        clk;
  wire        rst;

  wire [63:0]  data_in_gold;
  wire 	data_in_valid_gold;
  wire 	pop_fifo_gold;

  wire [63:0] data_out_gold;
  wire        fifo_empty_gold;
  wire        fifo_full_gold;
  wire        data_out_valid_gold;


  
  fifo_hier DUT (                    // Outputs
       			      data_out, fifo_empty, fifo_full, data_out_valid,
       			      // Inputs
       			      data_in, data_in_valid, pop_fifo);

  fifo_simple_gold GOLD (                    // Outputs
       			      data_out_gold, fifo_empty_gold, fifo_full_gold, data_out_valid_gold,
       				                                      // Inputs
       				data_in_gold, data_in_valid_gold, pop_fifo_gold, clk, rst);

  
  assign               clk = DUT.clk_generator.clk;
  assign               rst = DUT.clk_generator.rst;

  assign data_in_gold = data_in;
  assign data_in_valid_gold = data_in_valid;
  assign pop_fifo_gold = pop_fifo;
  
  always @ (posedge clk)
    begin
       data_in[31:0] = $random;
       data_in[63:32] = $random;
       // data_in_valid = $random%2;
       
    end

  initial
    begin
       data_in_valid = 1'b0;
       pop_fifo = 1'b0;
       #5000 $finish;
       
    end

  always @ (posedge clk)
    begin
       data_in_valid = $random%2;
       pop_fifo = $random % 2;
    end

  always @ (posedge clk)
    begin
       if (fifo_full !== fifo_full_gold)
         $display("MINORCHECK : FULL logic : full = %d, full_gold = %d", fifo_full, fifo_full_gold);
       if (fifo_empty !== fifo_empty_gold)
         $display("MINORCHECK : EMPTY logic : empty = %d, empty_gold = %d", fifo_empty, fifo_empty_gold);
       if (data_out !== data_out_gold && data_out_valid_gold === 1'b1)
       begin
         err = 1'b1;
         $display("ERRORCHECK : Data out error");
       end
       else
         err = 1'b0;
       //if(data_out_valid_gold == 1'b1)
         //$display("DEBUG : out_valid %d", data_out_gold);
        
    end
  
endmodule
